% % %---------------------------- ʱȭ ---------------------------- % % %

function varargout = main(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @main_OpeningFcn, ...
                   'gui_OutputFcn',  @main_OutputFcn, ...
                   'gui_LayoutFcn',  @main_LayoutFcn, ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end



function main_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

guidata(hObject, handles);



function varargout = main_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;

set(handles.figure_main, 'Visible', 'on');

global loaded_1;
global loaded_2;
global loaded_3;
global exiting_2;
global exiting_3;


% â ó   ʱȭ %
if ( isempty(loaded_1) || (loaded_1 ~= 1) )
    f_windows_handles(guihandles, 'w1');
    loaded_1 = 1;
    exiting_2 = 0;
    exiting_3 = 0;
    f_db(0, 'i', 24206);
end


%  ȿ ( Ͱ ƴ) üũϰ,   ư Ȱȭ, Ȱȭ %





%  " Էâ" Ѿ 
if ( exiting_2 == 1 )
    set(handles.pushbutton_input_income, 'Enable', 'on');
    loaded_2 = 0;
    exiting_2 = 0;
elseif ( exiting_3 == 1)
    set(handles.pushbutton_input_income, 'Enable', 'on');
	set(handles.pushbutton_clear_income, 'Enable', 'on');
	set(handles.pushbutton_output_result, 'Enable', 'on');
end


loaded_2 = 0;
loaded_3 = 0;


set(handles.uitable_info, 'Data', ([f_db(0, 'r', 0); f_db(0, 'r', 5); f_db(0, 'r', 6)])'); % ǥ  ΰħ

% "  " ΰħ %
total_income = sum(f_db(0, 'r', 7)) * 24;
if ( total_income >= 10^8 )
    total_income_str = [num2str(floor(total_income/(10^8))), ' ', num2str(floor(rem(total_income, 10^8)/(10^4))), ' ', num2str(rem(total_income, 10^4)), ' '];
elseif ( total_income >= 10^4 )
    total_income_str = [num2str(floor(rem(total_income, 10^8)/(10^4))), ' ', num2str(rem(total_income, 10^4)), ' '];
else
    total_income_str = [num2str(rem(total_income, 10^4)), ' '];
end
set(handles.text_total_income, 'String', total_income_str);

% "   " ΰħ %
set(handles.text_num_of_income_month, 'String', [num2str(sum(~~f_db(0, 'r', 0))), ' ']);

% "ü ִ  " ΰħ %
set(handles.text_num_of_overdue_month, 'String', [num2str(sum(~~f_db(0, 'r', 6))), ' ']);

% " " ΰħ %
set(handles.text_num_of_employee, 'String', [num2str(numel(f_db(0, 'r', 7))), ' ']);







% % %----------------------------- ü ----------------------------- % % %


% " Է" ư
function pushbutton_input_income_Callback(hObject, eventdata, handles)


% " â"  ư Ȱȭ %
set(handles.pushbutton_input_income, 'Enable', 'off');
set(handles.pushbutton_clear_income, 'Enable', 'off');
set(handles.pushbutton_output_result, 'Enable', 'off');
set(handles.pushbutton_exit, 'Enable', 'off');


h_input_income = guihandles(input_income);
set(h_input_income.figure_input_incomes, 'Visible', 'on'); % " Էâ" 
f_windows_handles(h_input_income, 'w2'); % " Էâ" ڵ 


% " ʱȭ" ư
function pushbutton_clear_income_Callback(hObject, eventdata, handles)

f_db(0, 'i', 24206); % db  ʱȭ


%  ΰħ %

set(handles.pushbutton_input_income, 'Enable', 'on');
set(handles.pushbutton_exit, 'Enable', 'on');

%  ȿ ¿  " â" ư Ȱȭ 
if ( numel(f_db(0, 'r', 7)) == 0 )
    set(handles.pushbutton_clear_income, 'Enable', 'off');
    set(handles.pushbutton_output_result, 'Enable', 'off');
else
    set(handles.pushbutton_clear_income, 'Enable', 'on');
    set(handles.pushbutton_output_result, 'Enable', 'on');
end


set(handles.uitable_info, 'Data', ([f_db(0, 'r', 0); f_db(0, 'r', 5); f_db(0, 'r', 6)])'); % ǥ  ΰħ

% "  " ΰħ %
total_income = sum(f_db(0, 'r', 7)) * 24;
if ( total_income >= 10^8 )
    total_income_str = [num2str(floor(total_income/(10^8))), ' ', num2str(floor(rem(total_income, 10^8)/(10^4))), ' ', num2str(rem(total_income, 10^4)), ' '];
elseif ( total_income >= 10^4 )
    total_income_str = [num2str(floor(rem(total_income, 10^8)/(10^4))), ' ', num2str(rem(total_income, 10^4)), ' '];
else
    total_income_str = [num2str(rem(total_income, 10^4)), ' '];
end
set(handles.text_total_income, 'String', total_income_str);

% "   " ΰħ %
set(handles.text_num_of_income_month, 'String', [num2str(sum(~~f_db(0, 'r', 0))), ' ']);

% "ü ִ  " ΰħ %
set(handles.text_num_of_overdue_month, 'String', [num2str(sum(~~f_db(0, 'r', 6))), ' ']);

% " " ΰħ %
set(handles.text_num_of_employee, 'String', [num2str(numel(f_db(0, 'r', 7))), ' ']);


% " м" ư callback 
function pushbutton_output_result_Callback(hObject, eventdata, handles)

% " â"  ư Ȱȭ %
set(handles.pushbutton_input_income, 'Enable', 'off');
set(handles.pushbutton_clear_income, 'Enable', 'off');
set(handles.pushbutton_output_result, 'Enable', 'off');

set(handles.figure_main, 'Visible', 'off'); % main â  ʵ 
h_output_result = guihandles(output_result); % " â"  ڵ ҷ
set(h_output_result.figure_output_result, 'Visible', 'on'); % " â" 
f_windows_handles(h_output_result, 'w3'); % " Էâ" ڵ 


% "α׷ " ư callback 
function pushbutton_exit_Callback(hObject, eventdata, handles)

figure_main_CloseRequestFcn(handles.figure_main, eventdata, handles); % α׷  








% % %----------------------------- Ÿ ----------------------------- % % %


%  â ŬǾ  
function figure_main_WindowButtonDownFcn(hObject, eventdata, handles)
global loaded_2;
global loaded_3;

h_input_income = f_windows_handles(2, 'r');

if ( loaded_2 == 1 )
    set(h_input_income.figure_input_incomes, 'Visible', 'on'); % " Էâ" ִ ¿ " â" ŬǾ , " Էâ" Ŀ 
elseif ( loaded_3 == 1 )
    set(output_result, 'Visible', 'on');
end


% α׷ 
function figure_main_CloseRequestFcn(hObject, eventdata, handles)
global loaded_1;
global loaded_2;
global loaded_3;

delete(handles.figure_main); % " â" ݱ

% â  Ǿ
loaded_1 = 0;
loaded_2 = 0;
loaded_3 = 0;








% % %--------------------  GUI   ʱȭ ---------------------% % %
% % %-------------------- (GUIDE .fig  ȯ) ---------------------% % %


% GUI  ü   , handle ȯ
function h1 = main_LayoutFcn(policy)


persistent hsingleton;
if strcmpi(policy, 'reuse') & ishandle(hsingleton)
    h1 = hsingleton;
    return;
end

mat={[~1, ~1, ~1]};


appdata = [];
appdata.GUIDEOptions = struct(...
    'active_h', [], ...
    'taginfo', struct(...
    'figure', 2, ...
    'pushbutton', 6, ...
    'uipanel', 7, ...
    'togglebutton', 2, ...
    'uitable', 3, ...
    'text', 26), ...
    'override', 0, ...
    'release', 13, ...
    'resize', 'none', ...
    'accessibility', 'callback', ...
    'mfile', 1, ...
    'callbacks', 1, ...
    'singleton', 1, ...
    'syscolorfig', 1, ...
    'blocking', 0, ...
    'lastSavedFile', 'D:\Documents\MATLAB\proj\main.m', ...
    'lastFilename', 'D:\Documents\MATLAB\proj\main.fig');
appdata.lastValidTag = 'figure_main';
appdata.GUIDELayoutEditor = [];
appdata.initTags = struct(...
    'handle', [], ...
    'tag', 'figure_main');

h1 = figure(...
'Units','characters',...
'PaperUnits',get(0,'defaultfigurePaperUnits'),...
'CloseRequestFcn',@(hObject,eventdata)main('figure_main_CloseRequestFcn',hObject,eventdata,guidata(hObject)),...
'Color',[0.941176470588235 0.941176470588235 0.941176470588235],...
'Colormap',[0 0 0.5625;0 0 0.625;0 0 0.6875;0 0 0.75;0 0 0.8125;0 0 0.875;0 0 0.9375;0 0 1;0 0.0625 1;0 0.125 1;0 0.1875 1;0 0.25 1;0 0.3125 1;0 0.375 1;0 0.4375 1;0 0.5 1;0 0.5625 1;0 0.625 1;0 0.6875 1;0 0.75 1;0 0.8125 1;0 0.875 1;0 0.9375 1;0 1 1;0.0625 1 1;0.125 1 0.9375;0.1875 1 0.875;0.25 1 0.8125;0.3125 1 0.75;0.375 1 0.6875;0.4375 1 0.625;0.5 1 0.5625;0.5625 1 0.5;0.625 1 0.4375;0.6875 1 0.375;0.75 1 0.3125;0.8125 1 0.25;0.875 1 0.1875;0.9375 1 0.125;1 1 0.0625;1 1 0;1 0.9375 0;1 0.875 0;1 0.8125 0;1 0.75 0;1 0.6875 0;1 0.625 0;1 0.5625 0;1 0.5 0;1 0.4375 0;1 0.375 0;1 0.3125 0;1 0.25 0;1 0.1875 0;1 0.125 0;1 0.0625 0;1 0 0;0.9375 0 0;0.875 0 0;0.8125 0 0;0.75 0 0;0.6875 0 0;0.625 0 0;0.5625 0 0],...
'IntegerHandle','off',...
'InvertHardcopy',get(0,'defaultfigureInvertHardcopy'),...
'MenuBar','none',...
'Name','޿  м',...
'NumberTitle','off',...
'PaperPosition',get(0,'defaultfigurePaperPosition'),...
'PaperSize',get(0,'defaultfigurePaperSize'),...
'PaperType',get(0,'defaultfigurePaperType'),...
'Position',[60 125 140.2 50.0769230769231],...
'Resize','off',...
'WindowButtonDownFcn',@(hObject,eventdata)main('figure_main_WindowButtonDownFcn',hObject,eventdata,guidata(hObject)),...
'HandleVisibility','callback',...
'UserData',[],...
'Tag','figure_main',...
'Visible','on',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'pushbutton_input_income';

h2 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback',@(hObject,eventdata)main('pushbutton_input_income_Callback',hObject,eventdata,guidata(hObject)),...
'Position',[30 4.53846153846154 19.8 1.53846153846154],...
'String',' Է',...
'Tag','pushbutton_input_income',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'uitable_info';

h3 = uitable(...
'Parent',h1,...
'Units','characters',...
'BackgroundColor',[0.96078431372549 0.976470588235294 0.992156862745098;0.870588235294118 0.92156862745098 0.980392156862745],...
'ColumnFormat',{  [] [] [] },...
'ColumnEditable',mat{1},...
'ColumnName',{  'ȸ '; 'ݿ ޿ '; '  ü' },...
'ColumnWidth',{  90 90 90 },...
'Data',[0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0;0 0 0],...
'Enable','inactive',...
'Position',[9.8 8.53846153846154 63.4 37.6153846153846],...
'UserData',[],...
'Tag','uitable_info',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'pushbutton_clear_income';

h4 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback',@(hObject,eventdata)main('pushbutton_clear_income_Callback',hObject,eventdata,guidata(hObject)),...
'Enable','off',...
'Position',[60 4.53846153846154 19.8 1.53846153846154],...
'String',' ʱȭ',...
'Tag','pushbutton_clear_income',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'pushbutton_output_result';

h5 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback',@(hObject,eventdata)main('pushbutton_output_result_Callback',hObject,eventdata,guidata(hObject)),...
'Enable','off',...
'Position',[90 4.53846153846154 19.8 1.53846153846154],...
'String',' м',...
'Tag','pushbutton_output_result',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'uipanel_num_of_income_month';

h6 = uipanel(...
'Parent',h1,...
'Units','characters',...
'Title','   ',...
'Tag','uipanel_num_of_income_month',...
'Clipping','on',...
'Position',[77.8 29.6153846153846 52.2 7],...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'text_num_of_income_month';

h7 = uicontrol(...
'Parent',h6,...
'Units','characters',...
'CData',[],...
'FontSize',15,...
'Position',[1.6 1.07692307692308 48.2 3.3],...
'String','0 ',...
'Style','text',...
'UserData',[],...
'Tag','text_num_of_income_month',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'uipanel_num_of_overdue_month';

h8 = uipanel(...
'Parent',h1,...
'Units','characters',...
'Title','ü ִ  ',...
'Tag','uipanel_num_of_overdue_month',...
'Clipping','on',...
'Position',[77.8 19.0769230769231 52.2 7],...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'text_num_of_overdue_month';

h9 = uicontrol(...
'Parent',h8,...
'Units','characters',...
'CData',[],...
'FontSize',14,...
'Position',[1.6 0.846153846153846 48.2 3.3],...
'String','0 ',...
'Style','text',...
'UserData',[],...
'Tag','text_num_of_overdue_month',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'uipanel_total_income';

h10 = uipanel(...
'Parent',h1,...
'Units','characters',...
'Title','  ',...
'Tag','uipanel_total_income',...
'Clipping','on',...
'Position',[77.8 39.7692307692308 52.2 7],...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'text_total_income';

h11 = uicontrol(...
'Parent',h10,...
'Units','characters',...
'CData',[],...
'FontSize',15,...
'Position',[1.6 0.923076923076923 48.2 3.3],...
'String','0 ',...
'Style','text',...
'UserData',[],...
'Tag','text_total_income',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'uipanel_num_of_employee';

h12 = uipanel(...
'Parent',h1,...
'Units','characters',...
'Title',' ',...
'Tag','uipanel_num_of_employee',...
'Clipping','on',...
'Position',[77.8 8.38461538461539 52.2 7],...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'text_num_of_employee';

h13 = uicontrol(...
'Parent',h12,...
'Units','characters',...
'FontSize',14,...
'Position',[1.6 0.769230769230769 48.2 3.3],...
'String','0 ',...
'Style','text',...
'Tag','text_num_of_employee',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );

appdata = [];
appdata.lastValidTag = 'pushbutton_exit';

h14 = uicontrol(...
'Parent',h1,...
'Units','characters',...
'Callback',@(hObject,eventdata)main('pushbutton_exit_Callback',hObject,eventdata,guidata(hObject)),...
'Position',[60 1.76923076923077 19.8 1.53846153846154],...
'String','α׷ ',...
'Tag','pushbutton_exit',...
'CreateFcn', {@local_CreateFcn, blanks(0), appdata} );


hsingleton = h1;


% , appdata     Լ ȣ
function local_CreateFcn(hObject, eventdata, createfcn, appdata)

if ~isempty(appdata)
   names = fieldnames(appdata);
   for i=1:length(names)
       name = char(names(i));
       setappdata(hObject, name, getfield(appdata,name));
   end
end

if ~isempty(createfcn)
   if isa(createfcn,'function_handle')
       createfcn(hObject, eventdata);
   else
       eval(createfcn);
   end
end


% GUI Ʈ   ü
function varargout = gui_mainfcn(gui_State, varargin)

gui_StateFields =  {'gui_Name'
    'gui_Singleton'
    'gui_OpeningFcn'
    'gui_OutputFcn'
    'gui_LayoutFcn'
    'gui_Callback'};
gui_Mfile = '';
for i=1:length(gui_StateFields)
    if ~isfield(gui_State, gui_StateFields{i})
        error(message('MATLAB:guide:StateFieldNotFound', gui_StateFields{ i }, gui_Mfile));
    elseif isequal(gui_StateFields{i}, 'gui_Name')
        gui_Mfile = [gui_State.(gui_StateFields{i}), '.m'];
    end
end

numargin = length(varargin);

if numargin == 0
    gui_Create = true;
elseif local_isInvokeActiveXCallback(gui_State, varargin{:})
    vin{1} = gui_State.gui_Name;
    vin{2} = [get(varargin{1}.Peer, 'Tag'), '_', varargin{end}];
    vin{3} = varargin{1};
    vin{4} = varargin{end-1};
    vin{5} = guidata(varargin{1}.Peer);
    feval(vin{:});
    return;
elseif local_isInvokeHGCallback(gui_State, varargin{:})
    gui_Create = false;
else
    gui_Create = true;
end

if ~gui_Create
    
    designEval = false;
    if (numargin>1 && ishghandle(varargin{2}))
        fig = varargin{2};
        while ~isempty(fig) && ~ishghandle(fig,'figure')
            fig = get(fig,'parent');
        end
        
        designEval = isappdata(0,'CreatingGUIDEFigure') || isprop(fig,'__GUIDEFigure');
    end
        
    if designEval
        beforeChildren = findall(fig);
    end
    
    varargin{1} = gui_State.gui_Callback;
    if nargout
        [varargout{1:nargout}] = feval(varargin{:});
    else       
        feval(varargin{:});
    end
    
    if designEval && ishghandle(fig)
        set(setdiff(findall(fig),beforeChildren), 'Serializable','off');
    end
else
    if gui_State.gui_Singleton
        gui_SingletonOpt = 'reuse';
    else
        gui_SingletonOpt = 'new';
    end

    gui_Visible = 'auto';
    gui_VisibleInput = '';
    for index=1:2:length(varargin)
        if length(varargin) == index || ~ischar(varargin{index})
            break;
        end

        len1 = min(length('visible'),length(varargin{index}));
        len2 = min(length('off'),length(varargin{index+1}));
        if ischar(varargin{index+1}) && strncmpi(varargin{index},'visible',len1) && len2 > 1
            if strncmpi(varargin{index+1},'off',len2)
                gui_Visible = 'invisible';
                gui_VisibleInput = 'off';
            elseif strncmpi(varargin{index+1},'on',len2)
                gui_Visible = 'visible';
                gui_VisibleInput = 'on';
            end
        end
    end
    
    gui_Exported = ~isempty(gui_State.gui_LayoutFcn);
    setappdata(0,genvarname(['OpenGuiWhenRunning_', gui_State.gui_Name]),1);
    if gui_Exported
        gui_hFigure = feval(gui_State.gui_LayoutFcn, gui_SingletonOpt);

        if isempty(gui_VisibleInput)
            gui_VisibleInput = get(gui_hFigure,'Visible');
        end
        set(gui_hFigure,'Visible','off')

        movegui(gui_hFigure,'onscreen');
    else
        gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt, gui_Visible);
        if isappdata(gui_hFigure, 'InGUIInitialization')
            delete(gui_hFigure);
            gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt, gui_Visible);
        end
    end
    if isappdata(0, genvarname(['OpenGuiWhenRunning_', gui_State.gui_Name]))
        rmappdata(0,genvarname(['OpenGuiWhenRunning_', gui_State.gui_Name]));
    end

    % GUI ʱȭ ÷ 
    setappdata(gui_hFigure,'InGUIInitialization',1);

    gui_Options = getappdata(gui_hFigure,'GUIDEOptions');
    gui_Options.singleton = gui_State.gui_Singleton;

    if ~isappdata(gui_hFigure,'GUIOnScreen')
        %  Ʈ
        if gui_Options.syscolorfig
            set(gui_hFigure,'Color', get(0,'DefaultUicontrolBackgroundColor'));
        end

        % handle ü   
        data = guidata(gui_hFigure);
        handles = guihandles(gui_hFigure);
        if ~isempty(handles)
            if isempty(data)
                data = handles;
            else
                names = fieldnames(handles);
                for k=1:length(names)
                    data.(char(names(k)))=handles.(char(names(k)));
                end
            end
        end
        guidata(gui_hFigure, data);
    end

    for index=1:2:length(varargin)
        if length(varargin) == index || ~ischar(varargin{index})
            break;
        end

        len1 = min(length('visible'),length(varargin{index}));
        if ~strncmpi(varargin{index},'visible',len1)
            try set(gui_hFigure, varargin{index}, varargin{index+1}), catch break, end
        end
    end

    % handle visibility callback  , ü  Ϸ on  
    gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
    if strcmp(gui_HandleVisibility, 'callback')
        set(gui_hFigure,'HandleVisibility', 'on');
    end

    feval(gui_State.gui_OpeningFcn, gui_hFigure, [], guidata(gui_hFigure), varargin{:});

    if isscalar(gui_hFigure) && ishghandle(gui_hFigure)
        
        guidemfile('restoreToolbarToolPredefinedCallback',gui_hFigure); 
        
        % handle visibility Ʈ
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);

        if ~gui_Exported
            gui_hFigure = local_openfig(gui_State.gui_Name, 'reuse',gui_Visible);
        elseif ~isempty(gui_VisibleInput)
            set(gui_hFigure,'Visible',gui_VisibleInput);
        end
        if strcmpi(get(gui_hFigure, 'Visible'), 'on')
            figure(gui_hFigure);
            
            if gui_Options.singleton
                setappdata(gui_hFigure,'GUIOnScreen', 1);
            end
        end

        % GUI ʱȭ Ϸ
        if isappdata(gui_hFigure,'InGUIInitialization')
            rmappdata(gui_hFigure,'InGUIInitialization');
        end

        % handle visibility callback  , ü  Ϸ on  
        gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
        if strcmp(gui_HandleVisibility, 'callback')
            set(gui_hFigure,'HandleVisibility', 'on');
        end
        gui_Handles = guidata(gui_hFigure);
    else
        gui_Handles = [];
    end

    if nargout
        [varargout{1:nargout}] = feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    else
        feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    end

    if isscalar(gui_hFigure) && ishghandle(gui_hFigure)
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);
    end
end

function gui_hFigure = local_openfig(name, singleton, visible)

if nargin('openfig') == 2
    gui_OldDefaultVisible = get(0,'defaultFigureVisible');
    set(0,'defaultFigureVisible','off');
    gui_hFigure = openfig(name, singleton);
    set(0,'defaultFigureVisible',gui_OldDefaultVisible);
else
    gui_hFigure = openfig(name, singleton, visible);  
    if feature('HGUsingMATLABClasses')
        peers=findobj(findall(allchild(gui_hFigure)),'type','uicontrol','style','text');    
        for i=1:length(peers)
            if isappdata(peers(i),'Control')
                actxproxy(peers(i));
            end            
        end
    end
end

function result = local_isInvokeActiveXCallback(gui_State, varargin)

try
    result = ispc && iscom(varargin{1}) ...
             && isequal(varargin{1},gcbo);
catch
    result = false;
end

function result = local_isInvokeHGCallback(gui_State, varargin)

try
    fhandle = functions(gui_State.gui_Callback);
    result = ~isempty(findstr(gui_State.gui_Name,fhandle.file)) || ...
             (ischar(varargin{1}) ...
             && isequal(ishghandle(varargin{2}), 1) ...
             && (~isempty(strfind(varargin{1},[get(varargin{2}, 'Tag'), '_'])) || ...
                ~isempty(strfind(varargin{1}, '_CreateFcn'))) );
catch
    result = false;
end


